c...This file felsb.for contains subroutines which are used by all the 
c...'main engines' except eladv.for. It should be compiled separately, 
c...and linked with the object files elast.obj, etc. If you don't use
c...linking, simply append the contents of this file to the end of the
c...'main engine' file (e.g. elast.for), before compiling it. 
c
      subroutine input(ichan,melem,mpoin,mnode,msets,mcomp,nelem,
     1      npoin,lnods,lnodn,lsidn,lmtyp,coord,nkode,lpros,props
     2            ,ndofn,npros,title,ndof)
c
c...this reads basic mesh data for all main engines except bigel
c
      implicit integer(i-o)
      dimension lnods(melem,mnode),lnodn(melem),lsidn(melem)
     1,nkode(mpoin),lpros(melem),coord(mpoin,2),cordn(2),
     2props(msets,mcomp),lmtyp(melem),ndof(mpoin)
c
c
      character*80 title
c
      rewind (ichan)
      read(ichan,501,err=99,end=199) title
      write(6,*) 'TITLE: ',title
c
      read(ichan,*)
      read(ichan,401,err=99,end=199) npoin,nelem,ndofn,npros
      if (npoin.gt.mpoin) then
        write(6,*)'ERROR: ',npoin,' nodes exceeds maximum.'
        write(6,*)'Increase MPOIN and recompile.'
        call prompt
        stop
      endif
      if (nelem.gt.melem) then
        write(6,*)'ERROR: ',nelem,' elements exceeds maximum.'
        write(6,*)'Increase MELEM and recompile.'
        call prompt
        stop
      endif
c
      do 11 i=1,melem
        lmtyp(i) = 0
        lnodn(i) = 0
        lsidn(i) = 0
        lpros(i) = 0
        do 11 j=1,mnode
          lnods(i,j) = 0
   11 continue
      do 12 i=1,mpoin
        nkode(i) = 0
        do 12 j=1,2
          coord(i,j) = 0.0
   12 continue
      do 13 i=1,msets
        do 13 j=1,mcomp
          props(i,j) = 0.0
   13 continue
c
c...read original elt-node connections
      k = 0
      read(ichan,*)
   15 k = k + 1
      read(ichan,421,err=99,end=199) lcard,nside,lmtype,nset,
     1lnum,(lnods(lnum,n),n=1,mnode)
      if (nside.eq.0) nside=4
c...count no. of nodes in element
      nnode = 0
      do 21 n=1,mnode
        if (lnods(lnum,n).eq.0) goto 22
        nnode = nnode + 1
   21 continue
   22 lsidn(lnum) = nside
      lnodn(lnum) = nnode
      lmtyp(lnum) = lmtype
      lpros(lnum) = nset
      if (lcard.eq.0) goto 15
      if (k.ne.nelem) then
        write(6,*) 'WARNING: no. of elements differs from NELEM'
        write(6,*) 'NELEM changed to ',k
        nelem = k
      endif
c
c...read nodal coord cards, & store in coord
      read(ichan,*)
   23 read(ichan,441,err=99,end=199) lcard,kode,n,(cordn(i),i=1,2)
     1,ndofnp
      if (n.gt.npoin) then
         write(6,*) 'WARNING: node no. ',n,' exceeds NPOIN'
         write(6,*) 'NPOIN increased to ',n
         npoin = n
      endif
      if (n.le.0.or.npoin.gt.mpoin) then
         write(6,*) 'ERROR: node no.',n,' exceeds MPOIN or is negative'
         call prompt
         stop
      endif
      do 24 i=1,2
        coord(n,i) = cordn(i)
   24 continue
      nkode(n) = kode
      ndof(n) = ndofnp
      if (lcard.eq.0) goto 23
c
      read(ichan,*)
   30 read(ichan,491,err=99,end=199) lcard,nset,icomp,value
      if (nset.gt.0) props(nset,icomp) = value
      if (lcard.eq.0) goto 30
c
      return
   99 write(6,*)'ERROR: wrong format in data file'
      call prompt
      stop
  199 write(6,*)'ERROR: end of file encountered during input'
      call prompt
      stop 
c
c
c...input formats
  501 format (a80)
  401 FORMAT(12I5)
  421 FORMAT(I1,I4,I2,I3,10I5)
  441 FORMAT(I1,I4,I5,2g10.3,I5)
  491 format(i1,i4,i5,10x,g10.3)
c
      end
c
c
c
c
      subroutine output(ichan,melem,mpoin,mnode,msets,mcomp,
     1            nelem,npoin,lnods,lnodn,lsidn,lmtyp,coord,
     2      nkode,lpros,props,ndofn,npros,title,ndof)
      character title*50
c
      dimension lnods(melem,mnode),lnodn(melem),lsidn(melem)
     1,coord(mpoin,2),nkode(mpoin),lmtyp(melem)
     2,lpros(melem),props(msets,mcomp),ndof(mpoin)
c
c...echo the input data to the .out file via channel ichan
c
      write(ichan,600) title
c
      write(ichan,*)'  npoin nelem ndofn npros'
      write(ichan,612) npoin,nelem,ndofn,npros
c
      lcard = 0
      write(ichan,*)'nside typ/set elt       nodes'  
      do 155 l=1,nelem
        if (l.eq.nelem) lcard=1
        nnode = lnodn(l)
        nside = lsidn(l)
        lmtype = lmtyp(l)
        nset = lpros(l)
        write(ichan,621) lcard,nside,lmtype,nset,l,
     1                   (lnods(l,n),n=1,nnode)
  155 continue
c
c...write nodal coords, fixities and dof.s
      lcard = 0
      write(ichan,*)'  kode node  x-coord  y-coord ndof'
      do 160 n=1,npoin
        if (n.eq.npoin) lcard=1
        kode = nkode(n)
        ndofnp = ndof(n)
        if (ndofnp.eq.1) then
        write(ichan,641) lcard,kode,n,(coord(n,i),i=1,2),ndofnp
        else if (ndofnp.eq.2) then
        write(ichan,642) lcard,kode,n,(coord(n,i),i=1,2),ndofnp
        else if (ndofnp.eq.3) then
        write(ichan,643) lcard,kode,n,(coord(n,i),i=1,2),ndofnp
        else 
        write(ichan,644) lcard,kode,n,(coord(n,i),i=1,2),ndofnp
        endif
  160 continue
c
c...write mat props to file
      lcard = 0
      write(ichan,*)'  set cmpnt        value'
      do 175 nset=1,npros
        do 175 icomp=1,mcomp
          value = props(nset,icomp)
          if (abs(value).gt.0.0) then
            write(ichan,691) lcard,nset,icomp,value
          endif
  175 continue
      lcard = 1
      write(ichan,691) lcard
c
  600 format(a50)
  612 format(5I5)
  621 FORMAT(I1,I4,I2,I3,10I5)
  641 format(i1,3x, i1, i5,2f10.5,i5)
  642 format(i1,2x,i2.2,i5,2f10.5,i5)
  643 format(i1,1x,i3.3,i5,2f10.5,i5)
  644 format(i1,   i4.4,i5,2f10.5,i5)
  691 format(i1,i4,3x,i2,10x,e10.3)
      return
      end
c
c
c
      subroutine print(ichan,melem,mpoin,mnode,msets,mcomp,
     1nelem,npoin,lnods,lnodn,lsidn,lmtyp,coord,nkode,lpros,
     2            props,ndofn,npros,title,ndof)
      implicit integer(i-o)
      character title*50
      dimension lnods(melem,mnode),lnodn(melem),lsidn(melem)
     1,coord(mpoin,2),nkode(mpoin),lmtyp(melem),ndof(mpoin)
     2,lpros(melem),props(msets,mcomp),kard(14)
c
c...echo input data to a .prt print file, in easy-to-read format
c
      write(ichan,*)
      write(ichan,*)'MESH DETAILS'
      write(ichan,*)'============'
      write(ichan,*)
c
        write(ichan,*)
        write(ichan,*)
        write(ichan,*)'Title is:'
        write(ichan,*)
        write(ichan,*) title
        write(ichan,*)
        write(ichan,*)
c
        write(ichan,*)'Integer problem constants'
        write(ichan,*)'-------------------------'
        write(ichan,*)
	write(ichan,603)'npoin = ',npoin,'   nelem = ',nelem
        write(ichan,*)
        if (abs(ndofn).eq.2) then
              write(ichan,*)'NDOFN=2: Elasticity problem'
        else if (abs(ndofn).eq.1) then 
              write(ichan,*)'NDOFN=1: Poisson/Laplace problem'
        else if (abs(ndofn).eq.3) then
              write(ichan,*)'NDOFN=3: Beam or frame analysis'
        else
          write(6,*)'Error: NDOFN =',ndofn,' not a valid value.'
        endif
        if (ndofn.lt.0) then
          write(ichan,*)'Advanced-level analysis'
        else
          write(ichan,*)'Basic-level analysis'
        endif
  603   format(a8,i5,a11,i5)
	write(ichan,*)
	write(ichan,*)
c
      if(ichan.eq.6) call prompt
      write(ichan,*) 'Element-node connection data'
      write(ichan,*) '----------------------------'
      write(ichan,*)
     1'Element  No. of  No. of  Matl     Nodes around element'
      write(ichan,*)
     1'number   sides   nodes   type'
      write(ichan,*)
      do 30 lnum=1,nelem
        if (ichan.eq.6.and.mod(lnum,25).eq.0) call prompt
        nside = lsidn(lnum)
        nnode = lnodn(lnum)
        lmtype = lmtyp(lnum)
	write(ichan,612)lnum,nside,nnode,lmtype,
     1                  (lnods(lnum,n),n=1,nnode)
  612   format(i5,i7,i8,i8,5x,8i5)
   30 continue
      write(ichan,*)
c
      if (ichan.eq.6) call prompt
      write(ichan,*)'Nodal Coordinates and fixities'
      write(ichan,*)'------------------------------'
      write(ichan,*)
      iflag = 0
      write(ichan,*)' Node     x-coord      y-coord  ndof fixity code'
      write(ichan,*)
      do 55 n=1,npoin
        ndofnp = ndof(n)
        kode = nkode(n)
      if (ichan.eq.6.and.mod(n,25).eq.0) call prompt
      write(ichan,'(i5,2(3x,f10.3),2i5)')n,(coord(n,m),m=1,2)
     1,ndofnp,kode
   55 continue
      write(ichan,*)
c
      if (ichan.eq.6) call prompt
      write(ichan,*)'Material Properties'
      write(ichan,*)'-------------------'
      write(ichan,*)
      iflag = 0
      do 90 nset=1,npros
      write(ichan,*)
      write(ichan,*)'Elts in mat. prop. set ',nset,':'
      nin = 1
   85 call scan(kard,nin,nout,nset,lpros,nelem)
      write(ichan,'(14i5)')(kard(i),i=1,14)
      nin = nout + 1
      if (nin.le.nelem) goto 85
   90 continue
      write(ichan,*)
      write(ichan,*)'The non-zero mat. properties are:'
      do 327 iset=1,npros
      write(ichan,*)
      write(ichan,*)'Set number ',iset
      write(ichan,*)
      do 327 j=1,mcomp
      val = props(iset,j)
      if (abs(val).le.0.0) goto 327
      write(ichan,*)'Component ',j,' has value ',val
  327 continue
      write(ichan,*)
      write(ichan,*)'*** End of Part A data ***'
      write(ichan,*)
      write(ichan,*)
      return
      end
c
c
c
       FUNCTION LENSTR(STR)
       CHARACTER*(*) STR
C
c...finds the length of a character string
       lc = len(str)
       DO 100 I=lc,1,-1
          IF(STR(I:I).NE.' ') THEN
                LENSTR=I
                RETURN
           END IF
100    CONTINUE
       LENSTR=0
       RETURN
       END
c
c
      subroutine scan(kard,lin,lout,lvalue,list,ldim)
      dimension list(ldim),kard(14)
c
c...used in s/r print to produce in kard a list of entries in list
c...whose value is ldim 
      lout = lin
      ki = 0
      do 5 i=1,14
      kard(i) = 0
    5 continue
      do 20 li=lin,ldim
      lout = li
      lvali = list(li)
      if (lvali.eq.lvalue) then
         ki = ki + 1
         if (ki.le.14) then
            kard(ki) = li
         else
            lout = lout - 1
            return
         endif
      endif
   20 continue
      return
      end
c
c
      subroutine yesno(char,askim)
      character char*1
      character*(*) askim
c
c...asks the yes/no question in askim, and returns y or n in char
    5 lc = lenstr(askim)
      write(6,*) askim(1:lc)
      read(5,'(a1)') char
      if (char.eq.'y'.or.char.eq.'Y') then
        char = 'y'
      else if (char.eq.'n'.or.char.eq.'N') then
        char = 'n'
      else
       write(6,*)'Type y for yes or n for no: '
       goto 5
      endif
      return
      end
c
c
      subroutine askfil(infile,iflag)
      character*80 infile,intemp
c
c...prompts the user to enter a filename
      iflag = 0
      write(6,*)'Type the name of the .dat input file: '
      read(5,500) intemp
  500 format(a8)
      lenin = lenstr(intemp)
      infile = intemp(1:lenin)//'.dat'
      lenin = lenin + 4
      return
      end
c
c
c
      subroutine prompt
c...causes a pause in output, until the user presses a key
      character*1 char
      write(6,*) 'Press Return to continue!'
      read(5,'(a1)') char
      return
      end
